## prog.utili
Class OccorrenzaOrdinata<E extends java.lang.Comparable<? super E>>

    java.lang.Object
      prog.utili.Occorrenza<E>
          prog.utili.OccorrenzaOrdinata<E>

All Implemented Interfaces:
  java.lang.Comparable<OccorrenzaOrdinata<E>>

    public class OccorrenzaOrdinata<E extends java.lang.Comparable<? super E>>

extends Occorrenza<E>
implements java.lang.Comparable<OccorrenzaOrdinata<E>>

Un'istanza della classe fornisce un contatore per le occorrenze di un oggetto; sulle istanze della classe è definita una relazione d'ordine che deriva da quella definita sul tipo parametro `E`.

Version:
  2.0
Author:
  Mauro Ferrari, Giovanni Pighizzini

Constructor Summary
`OccorrenzaOrdinata(E o)` Crea una nuova `Occorrenza` che permette di contare le occorrenze dell'oggetto specificato come argomento, il valore iniziale del contatore è 1.
`OccorrenzaOrdinata(E o, int contatore)` Crea una nuova `Occorrenza` che permette di contare le occorrenze dell'oggetto specificato come primo argomento in cui il contatore è inizializzato al valore specificato come secondo argomento.
`OccorrenzaOrdinata(Occorrenza<E> o)` Crea una nuova istanza della classe a partire dall'occorrenza specificata come argomento.

Method Summary
`int` `compareTo(OccorrenzaOrdinata<E> altra)` Restituisce un intero negativo, zero o un intero positivo a seconda che l'oggetto a cui si riferisce l'occorrenza preceda, sia uguale o segua quello a cui si riferisce l'occorrenza fornita come argomento.

`static

`<E extends java.lang.Comparable<? super E>> OccorrenzaOrdinata<E>`

`

`fromOccorrenza(Occorrenza<E> o)`
Restituisce l'occorrenza ordinata corrispondente all'occorrenza specificata come argomento, cioè l'occrrenza ordinata è un contatore per lo stesso oggetto e con lo stesso valore del contatore di quella fornita come argomento.

Methods inherited from class prog.utili.Occorrenza
`equals, equals, get, getValoreContatore, incrementa, toString`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### OccorrenzaOrdinata

    public OccorrenzaOrdinata(E o)

  Crea una nuova `Occorrenza` che permette di contare le occorrenze dell'oggetto specificato come argomento, il valore iniziale del contatore è 1.

  Parameters:
    `o` - l'oggetto a cui si riferisce l'occorrenza.

### OccorrenzaOrdinata

    public OccorrenzaOrdinata(E o,
                              int contatore)

  Crea una nuova `Occorrenza` che permette di contare le occorrenze dell'oggetto specificato come primo argomento in cui il contatore è inizializzato al valore specificato come secondo argomento.

  Parameters:
    `o` - l'oggetto a cui si riferisce l'occorrenza.
    `contatore` - il valore iniziale del contatore.

### OccorrenzaOrdinata

    public OccorrenzaOrdinata(Occorrenza<E> o)

  Crea una nuova istanza della classe a partire dall'occorrenza specificata come argomento.

  Parameters:
    `o` - l'occorrenza per cui costruire l'oggetto.

Method Detail

### compareTo

    public int compareTo(OccorrenzaOrdinata<E> altra)

  Restituisce un intero negativo, zero o un intero positivo a seconda che l'oggetto a cui si riferisce l'occorrenza preceda, sia uguale o segua quello a cui si riferisce l'occorrenza fornita come argomento. L'ordinamento è stabilito dal metodo `compareTo` di `E`.

  Specified by:
    `compareTo` in interface `java.lang.Comparable<OccorrenzaOrdinata<E extends java.lang.Comparable<? super E>>>`
  Parameters:
    `altra` - l'occorrenza da confrontare con quella che esegue il metodo.
  Returns:
    un intero negativo, zero o un intero positivo a seconda che l'oggetto a cui si riferisce l'occorrenza preceda, sia uguale o segua rispetto all'ordine stabilito dal metodo `compareTo` di `E` quello a cui si riferisce l'oggetto fornito come argomento.

### fromOccorrenza

    public static <E extends java.lang.Comparable<? super E>> OccorrenzaOrdinata<E> fromOccorrenza(Occorrenza<E> o)

  Restituisce l'occorrenza ordinata corrispondente all'occorrenza specificata come argomento, cioè l'occrrenza ordinata è un contatore per lo stesso oggetto e con lo stesso valore del contatore di quella fornita come argomento.

  Parameters:
    `o` - l'occorrenza per cui costruire l'occorrenza ordinata.
  Returns:
    l'occorrenza ordinata corrispondente all'occorrenza fornita come argomento.